RequireScript('wavelib.js'); // Create simple .wav files (uncompressed 8 bit 22Khz)
RequireScript('acusthica.js'); // Used for playing some tunes with the created wav's

function game(){

	sfx1 = new WAVE();
	sfx2 = new WAVE();
	sfx3 = new WAVE();
	sfx4 = new WAVE();
	
	sfx1.generate(WAVE.SINE, 440,50,0.5);
	sfx2.generate(WAVE.TRIANGLE, 220,50,0.4);
	sfx3.generate(WAVE.SQUARE, 880,50,0.5);
	sfx4.generate(WAVE.WHITENOISE, 220,80,1);

	sfx4.lowpass(0.2); // very strong lowpass

	// Mix two sounds (should divide volume by 2, but volume 50+50<255)
	for(var i=0;i<sfx1.WAVE.length;++i){
		sfx1.WAVE[i] = (sfx1.WAVE[i]+sfx2.WAVE[i]);
	}
	
	// Save it all
	sfx1.save("test1.wav");
	sfx2.save("test2.wav");
	sfx3.save("test3.wav");
	sfx4.save("test4.wav");


	EnhanceAcusthica(); // Add some useful functions
	Piano = new AcusthicaEngine(); // Create a sound play thingy
	
	// Load back the saved wav's
	Piano.sfxLoad("../other/test1.wav");
	Piano.sfxLoad("../other/test2.wav");
	Piano.sfxLoad("../other/test3.wav");
	Piano.sfxLoad("../other/test4.wav");
	
	// Play a tune
	Piano.setSound("../other/test1.wav","../other/test2.wav", "../other/test3.wav","../other/test4.wav");
	Piano.play("C","E","G","");
	Piano.play("D","E","F","");
	Piano.play("E","G","F","");
	Piano.play("C","C","E");
	Piano.play("E", "c","d");
	Piano.play("D", "d","a");
	Piano.play("E", "G#","f#","C");
	Piano.play("G", "f#");
	Piano.play("A#");
	Piano.play("B", "G","F");
	Piano.play("C", "C", "c");
	
}


function EnhanceAcusthica(){

	// Load sounds and keep them ready
	AcusthicaEngine.prototype.setSound = function(filename1,filename2,filename3,filename4, volume,pan) {
		this.sfxsound1 = filename1;
		this.sfxsound2 = filename2;
		this.sfxsound3 = filename3;
		this.sfxsound4 = filename4;
		if(!this.Sounds[filename1]) this.sfxLoad(filename1);
		if(!this.Sounds[filename2]) this.sfxLoad(filename2);
		if(!this.Sounds[filename3]) this.sfxLoad(filename3);
		if(!this.Sounds[filename4]) this.sfxLoad(filename4);
		this.volume = volume || 67;
		this.pan = pan || 0;
	}
	
	// Play sounds
	AcusthicaEngine.prototype.play = function(pitch1,pitch2,pitch3,pitch4) {
		if(pitch1) this.sfx(this.sfxsound1,this.volume,this.pan,pitch1);
		if(pitch2) this.sfx(this.sfxsound2,this.volume,this.pan,pitch2);
		if(pitch3) this.sfx(this.sfxsound3,this.volume,this.pan,pitch3);
		if(pitch4) this.sfx(this.sfxsound4,this.volume,this.pan,pitch4);
		while(this.Sounds[this.sfxsound1].isPlaying()){} // Wait until done (blocks all activities)
	}
	
}